# 商米云打印机合作伙伴对接说明 V1.0

> ##### 特别声明：
> 商米云打印机对接通道为更好的保护合作伙伴的数据隐私，又能实现完整的订单打印过程，特订立以下对接规范，并需要商米与合作伙伴双方共同努力才能实现打印通道业务。

## 1、了解一下对接流程
![流程图](http://cdn.lyafei.com/%E6%B5%81%E7%A8%8B.jpg "流程图")

* ①在 https://partner.sunmi.com/ 注册一个合作伙伴平台账户，并获得账户CID关键字，用于接口API调用时使用；开通商米云打印机通道服务，并获得服务APP _ID、APP_KEY，用于接口API调用时使用；待合作伙伴接口开发上线后，还需要提供一个合作伙伴云URL给到商米云服务，用于让打印机回调合作伙伴API接口完成打印业务；
* ②合作伙伴业务APP中，“商米配网SDK”提供了一个简单易用的蓝牙配置WIFI联网开发过程，简单调用就可以让打印机连接上云端；
* ③SDK配网过程会自动获得打印机设备SN号，这个SN是设备的唯一标识符，利用它就可以绑定对应的商家账号完成业务通讯；
* ④合作伙伴业务APP中，使用SN号去合作伙伴云建立设备与商家店铺的关联关系；
* ⑤合作伙伴业务APP中，使用SN号调用商米云API绑定接口，建立设备SN与合作伙伴ID、商铺ID的关联关系；
* ⑥合作伙伴云对接商米订单推送、声音推送等API接口，建立起消息通讯通道；
* ⑦商米云在接收到推送消息以后，会自动向打印机下发业务消息；
* ⑧打印机在收到触发消息以后，使用之前提供的合作伙伴云URL去回调API接口获取订单的打印内容，并打印出来；
* ⑨打印业务对接完成以后，如果还需要进一步管理设备时，可以在合作伙伴业务APP中直接调用商米“设备管理页面”进行打印管理。更多的打印机设置内容将不断的完善，让商家可以获得更好的体验。

<br/>

## 2、注册一个合作伙伴账号
* a) 合作伙伴业务需基于商米云提供的安全保障前提下，所以要求合作伙伴需要拥有一个商米合作伙伴平台账户。
> 关于注册合作伙伴流程请参考：https://docs.sunmi.com/developers/registration-for-partners/

* b) 要求打印机设备在商米公司出库时渠道一定要选择该账户下，否则打印机会因归属权问题无法进行下一步绑定业务。

<br/>

## 3、下载配网SDK
> 安卓SDK DEMO下载链接：待更新<br>微信小程序SDK下载链接：待更新

> 说明：云打印机配网、云绑定过程是通过蓝牙实现的，所以需要利用手机的蓝牙来进行指令的通讯。SDK里的SunmiPrinterClient类对蓝牙配网过程进行了封装，便于APP简单开发实现打印机配对。使用该功能时必须保证蓝牙打开且允许应用获取位置权限。下面是SDK接口的使用说明，具体使用可以参考DEMO。

<br/>

## 3.1安卓配网SDK类说明

### 1)类声明

#### 接口名：

* SunmiPrinterClient

#### 接口声明：

```Java
   SunmiPrinterClient sunmiPrinterClicent = SunmiPrinterClient(Context context, IPrinterClient iPrinterClient);
```

#### 传入参数：

|参数名 |类型|说明|
|---|---|---|
| context | Context | |
| iPrinterClient | IPrinterClient | 云打印机蓝牙接口的回调类

<br/>

### 2)统一处理回调接口

> 配置蓝牙打印机的过程中需要通过BLE给蓝牙打印机发送消息，这里采用统一的回调处理蓝牙数据发送情况。

#### 接口名：

* sendDataFail

#### 回调方法：

```Java
   public void sendDataFail(int code, String msg) {
       
    }
```

#### 回调参数：
|参数名 |类型|说明|
|---|---|---|
| code | int | 错误信息码 0-蓝牙连接失败 1-蓝牙Notify失败 |
| msg | String | 错误信息 |

<br/>

## 3.2安卓配网SDK接口说明

### 1)开始扫描打印机

#### 接口名：

* startScan

#### 接口声明：

```Java
   sunmiPrinterClient.startScan();
```

#### 回调方法：

```Java
    public void onPrinterFount(PrinterDevice printerDevice) {
       
    }
```

#### 回调参数：

|参数名 |类型|说明|
|---|---|---|
| printerDevice | PrinterDevice | 蓝牙打印机类 扫描到的打印机数据中只有默认的名称和蓝牙mac地址|

<br/>

### 2) 停止扫描打印机

> 接口没有回调，建议在当前页面销毁或者开始配置打印机前停止扫描

#### 接口名：

* stopScan

#### 接口声明：

```Java
   sunmiPrinterClient.stopScan();
```

<br/>

### 3) 获取蓝牙打印机SN

#### 接口名：

* getPrinterSn

#### 接口声明：

```Java
   sunmiPrinterClient.getPrinterSn(btAddress);
```

#### 传入参数：

|参数名 |类型|说明|
|---|---|---|
| btAddress | String | 打印机的蓝牙MAC地址 |

#### 回调方法：

* 方法一：

```Java
   public void getSnRequestSuccess() {
        
    }
```

> 说明：该方法表示发送获取SN的命令成功，等待获取SN，该方法内可以加入超时机制


* 方法二：

```Java
   public void onSnReceived(String sn) {
        
    }
```

#### 回调参数：

|参数名 |类型|说明|
|---|---|---|
| sn | String | 打印机的sn |

<br/>

### 4)获取打印机搜索到的WIFI列表

#### 接口名：

* getPrinterWifiList

#### 接口声明：

```Java
   sunmiPrinterClient.getPrinterWifiList(btAddress);
```

#### 传入参数：

|参数名 |类型|说明|
|---|---|---|
| btAddress | String | 打印机的蓝牙MAC地址 |

#### 回调方法：

* 方法一：

```Java
   public void routerFound(Router router) {
        
    }
```

> #### 回调参数：
> |参数名 |类型|说明|
> |---|---|---|
> | router | Router | 打印机搜索到的WIFI类 |

> Router类参数说明

> |参数名 |类型|说明|
> |---|---|---|
> | name | String | WIFI的名字 |
> | hasPwd | boolean | WIFI是否有密码 |
> | pwd | String | WIFI的密码，此时获取到的WIFI没有该数据 |
> | rssi | int | WIFI的信号强度范围0到4，越大信号越强 |
> | essid | byte[] | WIFI的essid，配网时需要该参数|

* 方法二：

```
public void onGetWifiListFinish() {
        
    }
```
> 说明：蓝牙打印机搜索WIFI结束

* 方法三：

```
public void onGetWifiListFail() {
        
    }
```

> 说明：蓝牙打印机搜索wifi失败

<br/>

### 5)给打印机配置wifi

#### 接口名：

* setPrinterWifi

#### 接口声明：

```Java
   sunmiPrinterClient.setPrinterWifi(btAddress, ssid, psw);
```

#### 传入参数：

|参数名 |类型|说明|
|---|---|---
| btAddress | String | 打印机的蓝牙MAC地址 |
| ssid | byte[] | WIFI的essid|
| pwd | String | WIFI的密码|

#### 回调方法：

* 方法一：

```Java
   public void onSetWifiSuccess() {
       
    }
```

> 说明：打印机收到需要配置的WIFI信息，开始尝试连接WIFI，这里建议添加超时机制

* 方法二：

```Java
   public void wifiConfigSuccess() {
       
    }
```

 > 说明：打印机设置WIFI成功

* 方法三：

```Java
   public void onWifiConfigFail() {
      
    }
```

> 说明：打印机设置WIFI失败，一般是输入的WIFI密码不正确导致

<br/>

### 6)退出配网过程

>说明：该方法只有统一的发送蓝牙信息失败的回调，该方法建议在onBackPressed方法中调用

#### 接口名：

* quitConfig

#### 接口声明：

```Java
   sunmiPrinterClient.quitConfig(btAddress);
```

#### 传入参数：

|参数名 |类型|说明|
|---|---|---|
| btAddress | String | 打印机的蓝牙MAC地址 |

<br/>

### 7)请求删除wifi 配置，并使用2G网络

> 说明：该方法只有统一的发送蓝牙信息失败的回调，如果打印机使用2G网络，不采用WIFI就可以调用该方法。

#### 接口名：

* deleteWifiInfo

#### 接口声明：

```Java
   sunmiPrinterClient.deleteWifiInfo(btAddress);
```

#### 传入参数：

|参数名 |类型|说明|
|---|---|---|
| btAddress | String | 打印机的蓝牙MAC地址 |

<br/>

### 8)断开和蓝牙打印机的蓝牙连接

> 说明：该方法需要在页面销毁的时候进行调用

#### 接口名：

* disconnect

#### 接口声明：

```Java
   sunmiPrinterClient.disconnect(btAddress);
```

#### 传入参数：

|参数名 |类型|说明|
|---|---|---|
| btAddress | String | 打印机的蓝牙MAC地址 |

<br/>

## 4、开发对接API接口
> ##### 特别声明：
> 为更好的保护合作伙伴的数据隐私，又能实现完整的订单打印过程，需要商米与合作伙伴共同努力一起实现。以下文档约定了云打印机通讯的两部分接口，一部分为商米云提供的API接口，提供给合作伙伴调用，以完成设备绑定相关和消息推送相关功能；一部分为合作伙伴需要开放给商米云打印机调用的API接口，以完成订单打印相关功能。

<br/>

#### 参数说明：
1. 每个请求的参数包含两部分：公共参数和私有参数，详细请看以下对应说明。
2. 以下每个接口只列出私有参数和返回结果，其他请看请求和公共参数说明。
3. 返回结果皆为json格式数据。

<br/>

#### 请求公共参数说明（所有请求都必须传递的参数）：
|请求参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考下面签名生成方式|
|app_id|string|商米提供的app_id，申请开通通道时获得|
|msn|string|设备SN号|
|timestamp|string|Unix时间戳（秒）|

<br/>

#### 返回公共参数说明：
|返回参数名|类型|说明|
|------|------|------|
|code|int|返回码，参见常见错误码列表|
|data|不指定|数据类型和内容详见私有返回参数data，如果有错误，返回null|
|msg|string|结果提示信息，如果有错误返回错误信息描述|

<br/>

#### 公共请求参数sign生成说明：
#### 签名算法：MD5

> ##### 签名生成方式举例(它假定所需参数如下)：<br> app_id:sm5b9b4daef3463 <br>storeId:SM0819 <br> msn:NT1234DF23456 <br> token:dhasjkdhajkdhajdkghjsakd

> * 步骤1：以“key=value”格式，按参数名称ASCII字典顺序排序:  
stringA=“app_id=sm5b9b4daef3463&msn=NT1234DF23456&storeId=SM0819&token=dhasjkdhajkdhajdkghjsakd”;

> * 步骤2：拼接的关键app_key，假定app_key是“dd3ac24736589ae17d333e362859bf4c”,那么  
stringB=stringA+“dd3ac24736589ae17d333e362859bf4c”

> * 步骤3：对stringB进行MD5加密得到最终签名sign，即sign=MD5(stringB)

> 基于以上签名生成方式，其中私密参数app_id和app_Key，由商米科技统一分配。

<br/>

#### 常见错误码说明：
|错误码|说明|
|------|------|
|10000|接口调用成功|
|20000|服务不可用|
|20001|授权失败|
|40001|缺少所需参数|
|40002|非法参数|

> 此上为全局常见错误码说明，后续会继续补充。除公共错误码以外，具体业务错误码参见具体业务接口内容。

<br/>

## 4.1 商米云API接口
> 基于合作伙伴数据隐私考虑，商米云不会直接获取打印数据，而是采用消息传递方式，由打印机直连合作伙伴云拉取所需数据进行打印。以下规范由商米云实现了几个基本功能接口，以完成设备绑定、订单消息通知、语音传递等相关功能。

<br/>

>请求URL地址（正式）：https://openapi.sunmi.com/

>请求URL地址（调试）：https://openapi.uat.sunmi.com/

### 1)打印机绑定接口

#### 接口名：
   * /v1/printer/printerAdd

#### 请求方式：
   * POST（推荐），GET

#### 公共参数：

|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|msn|string|设备SN号|
|timestamp|string|Unix时间戳（秒）|

#### 私有参数：

|参数名|类型|说明|
|------|------|------|
|shop_id|string|合作伙伴名下的商户Id|

> shop_id是对名下设备进行分组管理的唯一条件，查询店铺设备状态列表时使用。若无需此功能可传null，那么店铺设备状态列表结果集将返回为空。

#### 返回示例：

```
{
  "code": "10000",
  "data": {
     "subCode": "60001",
     "subData": "",
     "subMessage": "",
  },
  "msg":  "string"
}
```

#### 返回参数说明：

|参数名|类型|说明|
|------|------|------|
|data|string|包含成功和失败信息|

#### 业务错误码说明：
|错误码|说明|
|------|------|
|60001|超出时间范围请求无效|
|60002|sn号不存在|
|60003|不属于该渠道设备|
|60004|绑定失败|

<br/>


### 2)打印机解绑接口

#### 接口名：
   * /v1/printer/printerUnBind

#### 请求方式：
   * POST（推荐），GET

#### 公共参数：
|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|msn|string|设备SN号|
|timestamp|string|Unix时间戳（秒）|

#### 私有参数：
|参数名|类型|说明|
|------|------|------|
|shop_id|string|合作伙伴名下的商户Id|

> shop_id必传，否则无法将该打印机从该店铺下解绑

#### 返回示例：

```
{
  "code": "10000",
  "data": {
     "subCode": "60001",
     "subData": "",
     "subMessage": "",
  },
  "msg":  "string"
}
```

#### 返回参数说明：

|参数名|类型|说明|
|------|------|------|
|data|string|包含成功和失败信息|

#### 业务错误码说明：
|错误码|说明|
|------|------|
|60001|超出时间范围请求无效|
|60002|sn号不存在|
|60003|不属于该渠道设备|
|60005|解绑失败|

<br/>

### 3)查询店铺下已绑定设备状态

#### 接口名：
   * /v1/machine/queryBindMachine

#### 请求方式：
   * POST（推荐），GET

#### 公共参数：

|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|timestamp|string|Unix时间戳（秒）|

#### 私有参数：

|参数名|类型|说明|
|------|------|------|
|shop_id|string|合作伙伴商户Id|

#### 返回示例：

```
{
    "code": "10000",
    "data": {
       "subCode": "60000",
       "subData": {
           "msn": "N302D96J40001",
           "is_online": 1
       },
       "subMessage": "",
    }
    "msg": "string"
}
```

#### 返回参数说明：

|参数名|类型|说明|
|------|------|------|
|subData|Object|msn:设备sn号；is_online:设备是否在线 1-在线 0-不在线|

#### 业务错误码说明：
|错误码|说明|
|------|------|
|60001|超出时间范围请求无效|
|60002|sn号不存在|
|60003|不属于该渠道设备|
|60006|商户Id不存在|

<br/>

### 4)有新订单消息通知

#### 接口名：
   * /v1/printer/newOrderNotice

#### 请求方式：
   * POST（推荐），GET

#### 公共参数：
|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|msn|string|设备SN号|
|timestamp|string|Unix时间戳（秒）|

#### 私有参数：
|参数名|类型|说明|
|------|------|------|
|hasOrder|int|1-有新的订单|
|orderId|int|订单Id|

#### 返回示例：

```
{
  "code": "10000",
  "data": {
     "subCode": "60000",
     "subData": "success",
     "subMessage": "",
  },
  "msg": "string"
}
```

#### 返回参数说明：
|参数名|类型|说明|
|------|------|------|
|subData|string|包含成功和失败信息|

#### 业务错误码说明：
|错误码|说明|
|------|------|
|60001|超出时间范围请求无效|
|60002|sn号不存在|
|60003|不属于该渠道设备|

<br/>

### 5)语音内容推送

#### 接口名：
   * /v1/printer/pushVoice

#### 请求方式：
   * POST（推荐），GET

#### 公共参数：
|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|msn|string|设备SN号|
|timestamp|string|Unix时间戳（秒）|

#### 私有参数：
|参数名|类型|说明|
|------|------|------|		
|call_content|string|语音播报内容|

#### 返回示例：

```
{
  "code": "10000",
  "data": {
     "subCode": "60000",
     "subData": "success",
     "subMessage": "",
  },
  "msg": "string"
}
```

#### 返回参数说明：

|参数名|类型|说明|
|------|------|------|
|subData|string|包含成功和失败信息|

#### 业务错误码说明：
|错误码|说明|
|------|------|
|60001|超出时间范围请求无效|
|60002|sn号不存在|
|60003|不属于该渠道设备|

<br/>

## 4.2 合作伙伴云API接口
> 基于合作伙伴数据隐私考虑，商米云不会直接获取打印数据，而是采用消息传递方式，由打印机直连合作伙伴云拉取所需数据进行打印。以下规范由合作伙伴云实现几个基本功能接口，以完成打印机设备获取订单数据进行打印。

>请求URL地址：为了让打印机设备能够直连合作伙伴云API接口实现订单打印功能，需要事先提供可以正常调用的URL地址给到商米云。

### 1)获取订单列表

#### 接口名：
   * printTicket/getPrintTicketOrderId

#### 请求方式：
   * GET

#### 参数：

|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|msn|string|设备SN号|
|timeStamp|string|Unix时间戳（秒）|

#### 返回示例（json）：

```
{
    "code":1,
    "data":["id","id","id","id","id"],
    "msg":""
}
```

#### 返回参数：

|参数名|说明|
|------|------|
|code|1代表请求成功，-1代表请求失败|
|data|返回数据库中五条订单id集合，若请求失败data为null|
|msg|若请求失败，msg返回error信息，请求成功则msg为null|

> 备注：为保证打印不漏单，订单id列表依照时间顺序每次最多返回5条订单id集合列表。打印机会将所有订单id内容依次打印完成后，再请求该接口获取需打印订单id列表，直至该接口返回为空停止。

<br/>

### 2)获取订单详情

#### 接口名：
   * printTicket/ getPrintTicketInfo

#### 请求方式：
   * GET

#### 参数：

|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|msn|string|设备SN号|
|timeStamp|string|Unix时间戳（秒）|
|orderId|string|订单id|

#### 返回示例（json）：

```
{
    "code":1,
    "data":{
	    "voice":"语音内容",
	    "data":"1B21306D4B8BD5310A",//使用ESCPOS指令字体倍高宽模式打印“测试1”内容，末尾还有一个回车指令
    },
    "msg":""
}
```

>  data说明：打印内容采用十六进制格式传输，所有文本内容采用UTF8编码。在内容中可以直接使用ESC/POS指令集控制打印，以获得所需的票据排版格式。

```
//PHP代码示例：  
$str = chr(0x1B).chr(0x21).chr(0x30)."测试打印票据Abcd".chr(0x0A);  // 1B 21 30是ESC/POS指令中的倍高倍宽；0A是指令中的换行
data = bin2hex(strToUtf8($str));  //data为：1b2130e6b58be8af95e68993e58db0e7a5a8e68dae416263640a

//该方法判断字符串内容是否是UTF8编码，如果是直接返回，如果不是则将字符串转换为UTF8编码
function strToUtf8($str){
    $encode = mb_detect_encoding($str, array("ASCII",'UTF-8',"GB2312","GBK",'BIG5'));
    if($encode == 'UTF-8'){
        return $str;
    }else{
        return mb_convert_encoding($str, 'UTF-8', $encode);
    }
}
```

#### 返回参数：

|参数名|说明|
|------|------|
|code|1 代表请求成功，-1代表请求失败|
|data|返回订单内容，voice为语音播报内容，data为订单详情，若请求失败data为null|
|msg|若请求失败，msg返回error信息，请求成功则msg为null|

> 云打印机因为具有重打订单功能，该接口需要允许状态已经标记为打印成功的订单，仍然允许打印机根据订单ID请求订单详情，以完成重打动作。

<br/>

### 3)更新订单状态

#### 接口名：
   * printTicket/ updatePrintTicketStatus

#### 请求方式：
   * GET

#### 参数：

|参数名|类型|说明|
|------|------|------|
|sign|string|签名，参考上面签名生成方式|
|app_id|string|商米提供的app_id|
|msn|string|设备SN号|
|timeStamp|string|Unix时间戳（秒）|
|orderId|string|订单id|
|status|int|状态 1:订单打印成功、0:订单打印失败、-1:订单json格式错误、-2:data字段内容为空|

#### 返回示例（json）：

```
{
    "code":1,
    "data":,"success",
    "msg":""
}
```

#### 返回参数：

|参数名|说明|
|------|------|
|code|1 代表请求成功，-1代表请求失败|
|data|成功返回“success”，失败返回“fail”|
|msg|若请求失败，msg返回error信息，请求成功则msg为null|

<br/>


## 5、打印机常用ESC/POS指令集

* #### LF 打印并走纸一行

|内容|说明|
|------|------|
|[格式]| ASCII：LF<br>Hex：0A<br>Decimal：10 |
|[描述]| · 标准模式下打印缓冲区内数据并走纸一行|
|[注释]| · 该指令将当前位置置于行首。|

<br/>

* #### ESC ! n 选择打印模式

|内容|说明|
|------|------|
|[格式]|ASCII：ESC ! n<br>Hex：1B 21 n<br>Decimal：27 33 n|
|[范围]|0≤n≤255|
|[描述]|设根据n的值设置字符打印模式<br>n=0字体标准大小<br>n=16字体倍高<br>n=32字体倍宽<br>n=48字体倍高宽|
|[注释]|· 所有字符以底端对齐。<br> · 对英数字符和汉字同时有效。|
|[默认值]|n=0|

<br/>

* #### ESC a n 选择对齐方式

|内容|说明|
|------|------|
|[格式]|ASCII：ESC a n<br>Hex：1B 61 n<br>Decimal：27 97 n|
|[范围]|0≤n≤2 或 48≤n≤50|
|[描述]|将一行数据按照指定的位置对齐如下n用以选择对齐方式：<br>0,48 左对齐<br>1,49 居中<br>2,50 右对齐|
|[注释]| · 标准模式下仅在一行的开始处时，该命令才有效。<br> · 该命令在打印区域执行对齐。|
|[默认值]|n=0|

<br/>

* #### ESC p m t1 t2 打开钱箱驱动脉冲

|内容|说明|
|------|------|
|[格式]|ASCII：ESC p m t1 t2<br>Hex：1B 70 m t1 t2<br>Decimal：27 112 m t1 t2|
|[范围]|m = 0, 1, 48, 49<br>0 ≤ t1 ≤ 255<br>0 ≤ t2 ≤ 255|
|[描述]| · m=0, 48 钱箱插座引脚2；m=1, 49 钱箱插座引脚5<br> · t1指定脉冲开启时间为[ t1 × 2 ms].<br> · t2指定脉冲关闭时间为[ t2 × 2 ms].<br>|
|[注释]| · 指定一个值(t1<t2)使得关闭时间长于开启时间|

<br/>

* #### GS V m 切刀裁纸

|内容|说明|
|------|------|
|[格式]|ASCII：GS V m<br>Hex：1D 56 m<br>Decimal：29 86 m|
|[范围]|m=1, 49|
|[描述]| · 选择一种切刀裁纸操作|
|[注释]| · 依据所装的自动裁纸器类型的不同，裁纸状态也不同。<br> · 仅在一行开头处理该命令时,该命令有效。<br> · 只有部分裁纸，没有完全裁纸。|

<br/>

* #### GS H n 选择条码字符的打印位置

|内容|说明|
|------|------|
|[格式]|ASCII：GS H n<br>Hex：1D 48 n<br>Decimal：29 72 n|
|[范围]|0≤n≤3 或 48≤n≤51|
|[描述]|打印条码时，为条码字符选择打印位置。<br>n指定条码字符打印位置：<br>0,48 不打印<br>1,49 在条码上方<br>2,50 在条码下方<br>3,51 在条码上方及下方|
|[默认值]|n = 0|

<br/>

* #### GS h n 选择条码高度

|内容|说明|
|------|------|
|[格式]|ASCII：GS h n<br>Hex：1D 68 n<br>Decimal：29 104 n|
|[范围]| 1≤n≤255|
|[描述]| · 设置条码的纵向高度。n设定垂直方向的点数（0.125mm/点）|
|[默认值]| n= 162|

<br/>

* #### GS w n 设置条形码宽度

|内容|说明|
|------|------|
|[格式]|ASCII：GS w n<br>Hex：1D 77 n<br>Decimal：29 119 n|
|[范围]|1≤n≤6|
|[描述]| · 设置条形码水平尺寸|
|[默认值]|n=3|

<br/>

* #### GS k m n d1...dn 打印条码

|内容|说明|
|------|------|
|[格式]|ASCII：GS k m n d1...dk<br>Hex：1D 6B m n d1...dk<br>Decima：29 107 m n d1...dk|
|[范围]|65≤ m ≤89（d1...dn长度取决于使用的条形码系统）|
|[描述]| · 选定条形码系统并打印。|
|[注释]| · n用来指示条码数据的个数，打印机将其后边n字节数据作为条码数据处理。<br> · 如果n超出了指定范围，则打印机停止该命令的处理，并将后续数据作为普通数据处理。<br> · 如果条码数据d超出了规定的范围，该命令无效。<br> · 如果条码横向超出了打印区域，无效。<br> · 这条命令不管由ESC2或ESC3命令设置的行高是多少，走纸距离都与设置 的条码高度相等。<br> · 这条命令只有在打印缓冲区没有数据时才有效，如果打印缓冲区有数据，该命令被忽略。<br> · 打印条码后，将打印位置设置在行首。|

m选定条形码系统如下：

|m|条形码系统|数据长度|字符个数|字符|范围|
|------|------|------|------|------|------|
|65| UPC-A| 固定| 11≤n≤12| 0~9| 48≤d≤57|
|66| UPC-E| 固定| 6≤n≤7| 0~9| 48≤d≤57|
|67| JAN13(EAN13)| 固定| 12≤n≤13| 0~9| 48≤d≤57|
|68| JAN8(EAN8)| 固定| 7≤n≤8| 0~9| 48≤d≤57|
|69| CODE39| 可变| 1≤n≤64| 0~9, A~Z, SP, $,<br> %, *, +, -, ., / |48≤d≤57, 65≤d≤90, 32,<br> 36, 37, 43, 45, 46, 47|
|70| Code 2 of 5 Interleaved| 可变| 2≤n≤64<br>(偶数）| 0~9| 48≤d≤57|
|71| CODABAR| 可变| 1≤n| 0~9, A~D, a~d,<br> $, +, -, ., /, : | 48≤d≤57, 65≤d≤68, 97≤d≤100,<br> 36, 43, 45, 46, 47, 58,<br> 65≤d1≤68, 97≤d1≤100,<br> 65≤dk≤68, 97≤dk≤100|
|72| CODE93| 可变| 1≤n≤64| | |
|73| CODE128| 可变| 2≤n≤64| | |
|81| Code 2 of 5 Matrix| 可变| 1≤n≤64| 0~9| 48≤d≤57|
|82| Code 2 of 5 Industrial| 可变| 1≤n≤64| 0~9| 48≤d≤57|
|83| Code 2 of 5 IATA| 可变| 1≤n≤64| 0~9| 48≤d≤57|
|84| Code 2 of 5 Datalogic| 可变| 1≤n≤64| 0~9| 48≤d≤57|
|85| CODE11| 可变| 1≤n≤64| 0~9, - | 48≤d≤57，45|
|86| CODE39 xtended| 可变| 1≤n≤64| | |
|87| GS1 DataBar| 固定| n=13| 0~9| 48≤d≤57|
|88| GS1 DataBar Expanded| 可变| | | |
|89| MSI Plessey| 可变| 1≤n≤64| 0~9| 48≤d≤57|

<br/>

## 6、需要了解的其他FAQ
#### a) 打印过程缺纸，订单会不会丢失？
答：当出现打印过程缺纸时，只要重新装好纸卷，未完成的票据将会自动完整的重新打印出来；

<br/>

#### b) 打印过程卡纸了，订单可不可以重新打印？
答：打印机提供按键重打功能，只要双击![](http://cdn.lyafei.com/%E8%8F%9C%E5%8D%95.jpg "菜单")键就可以重新打印最后一张订单；

<br/>

#### c) 店铺WIFI网络不好导致丢单怎么办？
答：网络状态因为影响因素众多，目前还没有终极的解决方案，所以购买WIFI+GPRS版本的打印机将自动带有弱网切换功能。在平时打印机将使用WIFI联网进行通讯，如果WIFI网络通讯不稳定时，打印机就会自动切换的GPRS网络进行通讯，等待WIFI恢复正常时再切换回来，避免了因此造成的订单无法接收的问题。因为GPRS的速率受限，接单体验上没有WIFI那么快，但因为GPRS属于备用通道，保证订单不丢失才是首要考虑的。

<br/>

#### d) 网络异常了，如何快速查找问题点？
答：网络状态因为影响因素众多，目前还没有终极的解决方案，所以打印机带有网络自检功能，只要双击![](http://cdn.lyafei.com/%E5%A4%8D%E4%BD%8D.jpg "复位")键，稍等几秒就会有一张网络自检票据打印出来，从票据中的FAIL项就可以分析网络目前处于何种故障，将故障信息提供给技术人员解决；

| 检测信息 | 信息说明 | 故障解决 |
| ------------ | ------------ | ------------ |
|Current Network|目前正在业务通讯的是WIFI网络还是GPRS网络。|如若未配置WIFI，请忽略此异常。如果一直处于GPRS网络，说明WIFI通路有问题，就需要检查一下打印机WIFI配置是否正确，或者路由器是否工作正常。如若未配置WIFI，请忽略此异常。|
|Link=>SSID:|目前连接的WIFI路由器SSID名称是什么，并且连接是否正常。连接上PASS，断开中FAIL。|没有SSID名称就说明打印机并没有配置WIFI，需要重新执行WIFI配网过程。如果有SSID名称，那就需要检查该SSID名称的WIFI路由器工作是否正常，或者打印机重新进行WIFI配网。|
|Link=>GPRS|目前的GPRS通道连接是否正常。连接上PASS，断开中FAIL|GPRS信号差，请将设备远离金属和多层墙壁的位置后，再次尝试。另GPRS连接速度比较慢，打印机刚开机还未连接上基站也会导致测试失败，稍等几分钟再测试一遍即可。|
|Check=>DHCP Conflict|检查网络环境中是否存在多个DHCP情况，多个DHCP或没有DHCP会导致网络连接异常。只有一个DHCP时PASS，有多个DHCP时Warn，没有DHCP为FAIL|本项依赖Link测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若Link=>SSID项未FAIL，请先确保其为Pass。<br>Warn表示网络中私搭的WIFI路由器导致DHCP冲突，请检查网络中是否存在多个路由器开启了DHCP模式。如果是请关闭多余的DHCP，只保留一个可以连接外网的即可。<br>FAIL表示网络中没有配置DHCP服务器，打印机无法获得IP地址。请检查网络中的DHCP服务器是否故障。|
|Check=>IP Conflict|检查网络环境中是否存在IP地址重复，多个IP地址相同会导致网络通讯异常。没有重复IP时PASS，有多个重复IP时FAIL|本项依赖Link测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若Link=>SSID项未FAIL，请先确保其为Pass。<br>网络中的多个DHCP服务冲突或者手工给设备配置IP地址时，就会引起IP地址冲突。请关闭多余的DHCP服务，或者找到冲突的IP地址设备，修改IP地址为使用DHCP分配。|
|Ping=>GW|检查设备与网关之间的链路，从而判断内网连接是否正常。返回值是延迟值，通过延迟值判断网络的速率是否达标，如果网关不通时FAIL|本项依赖Check测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若Check=>DHCP Confilict项FAIL，请先确保其为Pass。<br>网关一般都指向了WIFI路由器或者基站本身，Ping值太高或者FAIL就需要检查WIFI路由器是否工作正常，或者移动基站信号不好。|
|Ping=>DNS|检查设备与公网根DNS之间的链路，从而判断是否已经连接上外网。返回值是延迟值，通过延迟值判断网络的速率是否达标，如果网关不通时FAIL|本项依赖Ping=>GW测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若Link=>GPRS、Ping=>GW项均为FAIL，请先确保其为Pass。<br>DNS根服务器是互联网上的主节点，能Ping通说明打印机已经连上了互联网。Ping值太高或者FAIL就需要检查WIFI路由器是否工作正常，或者移动基站信号不好。|
|Ping=>MQTT Server|检查设备与MQTT服务器的链路，从而判断是否已经连接上业务服务器。返回值是延迟值，通过延迟值判断网络的速率是否达标，如果网关不通时FAIL|本项依赖Ping=>GW、Ping=>DNS测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若Link=>GPRS、Ping=>GW项均为FAIL，请先确保其为Pass。<br>MQTT是订单推送服务器，能Ping通说明订单推送服务器链路正常。Ping值太高或者FAIL就需要咨询设备厂商客服人员进行检查。|
|Ping=>HTTP Server|检查设备与HTTP服务器的链路，从而判断是否已经连接上业务服务器。返回值是延迟值，通过延迟值判断网络的速率是否达标，如果网关不通时FAIL|本项依赖Ping=>GW、Ping=>DNS测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若Link=>GPRS、Ping=>GW项均为FAIL，请先确保其为Pass。<br>HTTP是订单内容服务器，能Ping通说明订单服务器链路正常。Ping值太高或者FAIL就需要咨询设备厂商客服人员进行检查。|
|MQTT=>Check Config|打印机通讯主要靠MQTT，所以会自动检查服务器信息是否正确，是否可以接收来自云的订单消息。信息正确时PASS，信息错误时FAIL|本项依赖Ping=>HTTP测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若Ping=>HTTPServer项为FAIL，请先确保其为Pass。<br>如果接入MQTT服务器的信息出现错误，就需要咨询设备厂商客服人员进行检查。|
|MQTT=>Connect|打印机通讯主要靠MQTT，检查MQTT目前是否连接着，是否可以接收来自云的订单消息。连接上PASS，断开中FAIL|本项依赖MQTT=>MQTT config测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若MQTT=>Check Config项为FAIL，请先确保其为Pass。<br>如果接入MQTT连接出现错误，就需要咨询设备厂商客服人员进行检查。|
|MQTT=>R&W|打印机通讯主要靠MQTT，检查MQTT通讯数据是否正常，是否可以接收来自云的订单消息。可以通讯PASS，无法通讯FAIL|本项依赖MQTT=>MQTT Link测试项为PASS情况下，FAIL的故障分析才有意义，否则请忽略以下分析内容。如若MQTT=>Connect项为FAIL，请先确保其为Pass。<br>如果接入MQTT服务器的信息出现错误，就需要咨询设备厂商客服人员进行检查。|

<br/>

#### e) 打印机自检页如何操作？
答：需要完整查看打印机硬件信息，可以通过自检页了解，只要按下![](http://cdn.lyafei.com/%E5%A4%8D%E4%BD%8D.jpg "复位") 键再按下![](http://cdn.lyafei.com/%E8%8F%9C%E5%8D%95.jpg "菜单")键后同时松开就可以打印出来；

<br/>

#### f) 打印机网络异常，手机接单后是否可以打印出来？
答：打印机支持网络、USB、蓝牙三种模式同时打印，网络异常时，可以通过手机添加蓝牙打印机，然后使用ESC/POS指令向蓝牙打印机发送数据。

<br/>

#### g) 打印出来的票据是乱码，怎么回事？
答：商米云打印机目前支持全球字库打印，所以采用UTF8编码格式，所以传输的文字都要转码成UTF8才能打印出来。采用UTF8编码后就可以实现票据内容多语种混打，满足一些行业服务特定外国人群时的双语种打印问题。

<br/>

#### h) 打印机网络异常了，但手机上还能收到单，怎么打印出来？
答：商米云打印机支持云、USB、BT事务打印模式，允许在连接网络打印的情况下，仍然可以通过USB和BT接收来自收银机和手机的数据进行打印。所以如果手机上有订单，可以让手机蓝牙连接打印机，将票据内容通过蓝牙发送给打印机打印即可。

<br/>

#### i) 播报语音内容是否可以修改？
答：商米云打印机采用TTS语音合成技术，无论你发什么文字，都可以转换成语音播报出来。也就是说只要场景需要，票据的菜品、联系方式、备注都可以按照你的想法读出来。但由于一些多音字的存在，某些特定的语句可能无法按照你的期望正确发音，所以可以将文字替换成相同发音的非多音字来播报。

<br/>

#### j) 如何进行打印机wifi配网？
答：商米云打印机采用的是蓝牙配网方式，这种方式可以有效避免手机和打印机不在同一个Wifi路由器环境下的跨网段配网问题。商米已经为开发者准备了3套蓝牙配网SDK，一套是用于安卓下的配网SDK，一套是用于苹果手机的配网SDK，还有一套是用于微信小程序的配网SDK。使用这三套SDK的基础原理都是让开发者很方便的调用蓝牙进行通讯，避免各种因为通讯异常造成的重连机制开发难度。