package com.sunmi.cloudprinterdemo.utils;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

/**
 * Description:
 *
 * @author linyuanpeng on 2019-09-12.
 */
public class NetworkUtils {
    /**
     * 检测网络是否可用
     */
    public static boolean isNetworkAvailable(Context context) {
        boolean isNetworkAvailable = false;
        if (context == null) return false;
        ConnectivityManager connectivity =
                (ConnectivityManager) (context.getSystemService(Context.CONNECTIVITY_SERVICE));
        NetworkInfo[] networkInfos = connectivity.getAllNetworkInfo();
        if (networkInfos == null)
            return false;

        for (NetworkInfo itemInfo : networkInfos) {
            if (itemInfo != null) {
                if (itemInfo.getState() == NetworkInfo.State.CONNECTED
                        || itemInfo.getState() == NetworkInfo.State.CONNECTING) {
                    isNetworkAvailable = true;
                    break;
                }
            }
        }
        return isNetworkAvailable;
    }
}
